/* util-string.c generated by valac 0.26.0, the Vala compiler
 * generated from util-string.vala, do not modify */

/* Copyright 2011-2014 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/* GLib's character-based substring function.*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))



gchar* g_utf8_substring (const gchar* str, glong start_pos, glong end_pos);
#define GEARY_STRING_EOS '\0'
gboolean geary_string_is_empty_or_whitespace (const gchar* str);
gboolean geary_string_is_empty (const gchar* str);
gint geary_string_count_char (const gchar* s, gunichar c);
gint geary_string_ascii_cmp (const gchar* a, const gchar* b);
gint geary_string_ascii_cmpi (const gchar* a, const gchar* b);
gboolean geary_string_ascii_equal (const gchar* a, const gchar* b);
gboolean geary_string_ascii_equali (const gchar* a, const gchar* b);
guint geary_string_stri_hash (const gchar* str);
guint geary_string_nullable_stri_hash (const gchar* str);
gboolean geary_string_stri_equal (const gchar* a, const gchar* b);
gboolean geary_string_nullable_stri_equal (const gchar* a, const gchar* b);
gboolean geary_string_is_numeric (const gchar* str);
gint geary_string_digit_to_int (gchar ch);
gchar* geary_string_uint8_to_hex (guint8* buffer, int buffer_length1);
gchar* geary_string_uint8_to_string (guint8* buffer, int buffer_length1);
gchar* geary_string_reduce_whitespace (const gchar* _s);
gchar* geary_string_safe_byte_substring (const gchar* s, gssize max_length);


static gchar string_get (const gchar* self, glong index) {
	gchar result = '\0';
	glong _tmp0_ = 0L;
	gchar _tmp1_ = '\0';
#line 996 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 997 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp0_ = index;
#line 997 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp1_ = ((gchar*) self)[_tmp0_];
#line 997 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	result = _tmp1_;
#line 997 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	return result;
#line 59 "util-string.c"
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 1115 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1116 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1116 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1117 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1117 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1118 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	result = _result_;
#line 1118 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	return result;
#line 82 "util-string.c"
}


gboolean geary_string_is_empty_or_whitespace (const gchar* str) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_ = NULL;
#line 16 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp2_ = str;
#line 16 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	if (_tmp2_ == NULL) {
#line 16 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		_tmp1_ = TRUE;
#line 97 "util-string.c"
	} else {
		const gchar* _tmp3_ = NULL;
		gchar _tmp4_ = '\0';
#line 16 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		_tmp3_ = str;
#line 16 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		_tmp4_ = string_get (_tmp3_, (glong) 0);
#line 16 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		_tmp1_ = _tmp4_ == GEARY_STRING_EOS;
#line 107 "util-string.c"
	}
#line 16 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	if (_tmp1_) {
#line 16 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		_tmp0_ = TRUE;
#line 113 "util-string.c"
	} else {
		const gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		gchar _tmp8_ = '\0';
#line 16 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		_tmp5_ = str;
#line 16 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		_tmp6_ = string_strip (_tmp5_);
#line 16 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		_tmp7_ = _tmp6_;
#line 16 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		_tmp8_ = string_get (_tmp7_, (glong) 0);
#line 16 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		_tmp0_ = _tmp8_ == GEARY_STRING_EOS;
#line 16 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		_g_free0 (_tmp7_);
#line 131 "util-string.c"
	}
#line 16 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	result = _tmp0_;
#line 16 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	return result;
#line 137 "util-string.c"
}


inline gboolean geary_string_is_empty (const gchar* str) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_ = NULL;
#line 20 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp1_ = str;
#line 20 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	if (_tmp1_ == NULL) {
#line 20 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		_tmp0_ = TRUE;
#line 151 "util-string.c"
	} else {
		const gchar* _tmp2_ = NULL;
		gchar _tmp3_ = '\0';
#line 20 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		_tmp2_ = str;
#line 20 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		_tmp3_ = string_get (_tmp2_, (glong) 0);
#line 20 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		_tmp0_ = _tmp3_ == GEARY_STRING_EOS;
#line 161 "util-string.c"
	}
#line 20 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	result = _tmp0_;
#line 20 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	return result;
#line 167 "util-string.c"
}


static gint string_index_of_char (const gchar* self, gunichar c, gint start_index) {
	gint result = 0;
	gchar* _result_ = NULL;
	gint _tmp0_ = 0;
	gunichar _tmp1_ = 0U;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
#line 920 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 921 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp0_ = start_index;
#line 921 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp1_ = c;
#line 921 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp2_ = g_utf8_strchr (((gchar*) self) + _tmp0_, (gssize) (-1), _tmp1_);
#line 921 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_result_ = _tmp2_;
#line 923 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp3_ = _result_;
#line 923 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	if (_tmp3_ != NULL) {
#line 192 "util-string.c"
		gchar* _tmp4_ = NULL;
#line 924 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp4_ = _result_;
#line 924 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		result = (gint) (_tmp4_ - ((gchar*) self));
#line 924 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		return result;
#line 200 "util-string.c"
	} else {
#line 926 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		result = -1;
#line 926 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		return result;
#line 206 "util-string.c"
	}
}


gint geary_string_count_char (const gchar* s, gunichar c) {
	gint result = 0;
	gint count = 0;
#line 23 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	g_return_val_if_fail (s != NULL, 0);
#line 24 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	count = 0;
#line 218 "util-string.c"
	{
		gint index = 0;
#line 25 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		index = 0;
#line 223 "util-string.c"
		{
			gboolean _tmp0_ = FALSE;
#line 25 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
			_tmp0_ = TRUE;
#line 25 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
			while (TRUE) {
#line 230 "util-string.c"
				const gchar* _tmp3_ = NULL;
				gunichar _tmp4_ = 0U;
				gint _tmp5_ = 0;
				gint _tmp6_ = 0;
				gint _tmp7_ = 0;
#line 25 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
				if (!_tmp0_) {
#line 238 "util-string.c"
					gint _tmp1_ = 0;
					gint _tmp2_ = 0;
#line 25 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
					_tmp1_ = index;
#line 25 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
					index = _tmp1_ + 1;
#line 25 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
					_tmp2_ = count;
#line 25 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
					count = _tmp2_ + 1;
#line 249 "util-string.c"
				}
#line 25 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
				_tmp0_ = FALSE;
#line 25 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
				_tmp3_ = s;
#line 25 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
				_tmp4_ = c;
#line 25 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
				_tmp5_ = index;
#line 25 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
				_tmp6_ = string_index_of_char (_tmp3_, _tmp4_, _tmp5_);
#line 25 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
				index = _tmp6_;
#line 25 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
				_tmp7_ = index;
#line 25 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
				if (!(_tmp7_ >= 0)) {
#line 25 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
					break;
#line 269 "util-string.c"
				}
			}
		}
	}
#line 27 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	result = count;
#line 27 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	return result;
#line 278 "util-string.c"
}


gint geary_string_ascii_cmp (const gchar* a, const gchar* b) {
	gint result = 0;
	GCompareFunc _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gint _tmp3_ = 0;
#line 30 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 30 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 31 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp0_ = g_strcmp0;
#line 31 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp1_ = a;
#line 31 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp2_ = b;
#line 31 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp3_ = _tmp0_ (_tmp1_, _tmp2_);
#line 31 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	result = _tmp3_;
#line 31 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	return result;
#line 304 "util-string.c"
}


gint geary_string_ascii_cmpi (const gchar* a, const gchar* b) {
	gint result = 0;
	gchar* aptr = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* bptr = NULL;
	const gchar* _tmp1_ = NULL;
#line 34 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 34 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 35 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp0_ = a;
#line 35 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	aptr = _tmp0_;
#line 36 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp1_ = b;
#line 36 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	bptr = _tmp1_;
#line 326 "util-string.c"
	{
		gboolean _tmp2_ = FALSE;
#line 37 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		_tmp2_ = TRUE;
#line 37 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		while (TRUE) {
#line 333 "util-string.c"
			gint diff = 0;
			gchar* _tmp3_ = NULL;
			gchar _tmp4_ = '\0';
			gchar* _tmp5_ = NULL;
			gchar _tmp6_ = '\0';
			gint _tmp7_ = 0;
			gchar* _tmp8_ = NULL;
			gchar* _tmp9_ = NULL;
			gchar* _tmp10_ = NULL;
#line 37 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
			if (!_tmp2_) {
#line 345 "util-string.c"
			}
#line 37 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
			_tmp2_ = FALSE;
#line 38 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
			_tmp3_ = aptr;
#line 38 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
			_tmp4_ = g_ascii_tolower (*_tmp3_);
#line 38 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
			_tmp5_ = bptr;
#line 38 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
			_tmp6_ = g_ascii_tolower (*_tmp5_);
#line 38 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
			diff = ((gint) _tmp4_) - ((gint) _tmp6_);
#line 39 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
			_tmp7_ = diff;
#line 39 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
			if (_tmp7_ != 0) {
#line 40 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
				result = diff;
#line 40 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
				return result;
#line 367 "util-string.c"
			}
#line 42 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
			_tmp8_ = aptr;
#line 42 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
			if ((*_tmp8_) == GEARY_STRING_EOS) {
#line 43 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
				result = 0;
#line 43 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
				return result;
#line 377 "util-string.c"
			}
#line 45 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
			_tmp9_ = aptr;
#line 45 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
			aptr = _tmp9_ + 1;
#line 46 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
			_tmp10_ = bptr;
#line 46 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
			bptr = _tmp10_ + 1;
#line 387 "util-string.c"
		}
	}
}


inline gboolean geary_string_ascii_equal (const gchar* a, const gchar* b) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gint _tmp2_ = 0;
#line 50 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 50 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 51 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp0_ = a;
#line 51 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp1_ = b;
#line 51 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp2_ = geary_string_ascii_cmp (_tmp0_, _tmp1_);
#line 51 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	result = _tmp2_ == 0;
#line 51 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	return result;
#line 412 "util-string.c"
}


inline gboolean geary_string_ascii_equali (const gchar* a, const gchar* b) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gint _tmp2_ = 0;
#line 54 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 54 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 55 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp0_ = a;
#line 55 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp1_ = b;
#line 55 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp2_ = geary_string_ascii_cmpi (_tmp0_, _tmp1_);
#line 55 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	result = _tmp2_ == 0;
#line 55 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	return result;
#line 435 "util-string.c"
}


guint geary_string_stri_hash (const gchar* str) {
	guint result = 0U;
	GHashFunc _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	guint _tmp4_ = 0U;
	guint _tmp5_ = 0U;
#line 58 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	g_return_val_if_fail (str != NULL, 0U);
#line 59 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp0_ = g_str_hash;
#line 59 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp1_ = str;
#line 59 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp2_ = g_utf8_strdown (_tmp1_, (gssize) (-1));
#line 59 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp3_ = _tmp2_;
#line 59 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp4_ = _tmp0_ (_tmp3_);
#line 59 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp5_ = _tmp4_;
#line 59 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_g_free0 (_tmp3_);
#line 59 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	result = _tmp5_;
#line 59 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	return result;
#line 467 "util-string.c"
}


guint geary_string_nullable_stri_hash (const gchar* str) {
	guint result = 0U;
	guint _tmp0_ = 0U;
	const gchar* _tmp1_ = NULL;
#line 63 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp1_ = str;
#line 63 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	if (_tmp1_ != NULL) {
#line 479 "util-string.c"
		const gchar* _tmp2_ = NULL;
		guint _tmp3_ = 0U;
#line 63 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		_tmp2_ = str;
#line 63 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		_tmp3_ = geary_string_stri_hash (_tmp2_);
#line 63 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		_tmp0_ = _tmp3_;
#line 488 "util-string.c"
	} else {
#line 63 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		_tmp0_ = (guint) 0;
#line 492 "util-string.c"
	}
#line 63 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	result = _tmp0_;
#line 63 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	return result;
#line 498 "util-string.c"
}


gboolean geary_string_stri_equal (const gchar* a, const gchar* b) {
	gboolean result = FALSE;
	GEqualFunc _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
#line 66 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 66 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 67 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp0_ = g_str_equal;
#line 67 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp1_ = a;
#line 67 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp2_ = g_utf8_strdown (_tmp1_, (gssize) (-1));
#line 67 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp3_ = _tmp2_;
#line 67 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp4_ = b;
#line 67 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp5_ = g_utf8_strdown (_tmp4_, (gssize) (-1));
#line 67 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp6_ = _tmp5_;
#line 67 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp7_ = _tmp0_ (_tmp3_, _tmp6_);
#line 67 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp8_ = _tmp7_;
#line 67 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_g_free0 (_tmp6_);
#line 67 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_g_free0 (_tmp3_);
#line 67 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	result = _tmp8_;
#line 67 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	return result;
#line 543 "util-string.c"
}


gboolean geary_string_nullable_stri_equal (const gchar* a, const gchar* b) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
#line 71 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp0_ = a;
#line 71 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	if (_tmp0_ == NULL) {
#line 558 "util-string.c"
		const gchar* _tmp1_ = NULL;
#line 72 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		_tmp1_ = b;
#line 72 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		result = _tmp1_ == NULL;
#line 72 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		return result;
#line 566 "util-string.c"
	}
#line 75 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp2_ = b;
#line 75 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	if (_tmp2_ == NULL) {
#line 76 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		result = FALSE;
#line 76 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		return result;
#line 576 "util-string.c"
	}
#line 78 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp3_ = a;
#line 78 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp4_ = b;
#line 78 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp5_ = geary_string_stri_equal (_tmp3_, _tmp4_);
#line 78 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	result = _tmp5_;
#line 78 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	return result;
#line 588 "util-string.c"
}


/**
 * Returns true if the string contains only whitespace and at least one numeric character.
 */
static gboolean string_get_next_char (const gchar* self, gint* index, gunichar* c) {
	gunichar _vala_c = 0U;
	gboolean result = FALSE;
	gint _tmp0_ = 0;
	gunichar _tmp1_ = 0U;
	gunichar _tmp2_ = 0U;
#line 1015 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1016 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp0_ = *index;
#line 1016 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp1_ = g_utf8_get_char (((gchar*) self) + _tmp0_);
#line 1016 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_vala_c = _tmp1_;
#line 1017 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp2_ = _vala_c;
#line 1017 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	if (_tmp2_ != ((gunichar) 0)) {
#line 613 "util-string.c"
		gint _tmp3_ = 0;
		gchar* _tmp4_ = NULL;
#line 1018 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp3_ = *index;
#line 1018 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp4_ = g_utf8_next_char (((gchar*) self) + _tmp3_);
#line 1018 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		*index = (gint) (_tmp4_ - ((gchar*) self));
#line 1019 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		result = TRUE;
#line 1019 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		if (c) {
#line 1019 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
			*c = _vala_c;
#line 628 "util-string.c"
		}
#line 1019 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		return result;
#line 632 "util-string.c"
	} else {
#line 1021 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		result = FALSE;
#line 1021 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		if (c) {
#line 1021 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
			*c = _vala_c;
#line 640 "util-string.c"
		}
#line 1021 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		return result;
#line 644 "util-string.c"
	}
#line 1015 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	if (c) {
#line 1015 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		*c = _vala_c;
#line 650 "util-string.c"
	}
}


gboolean geary_string_is_numeric (const gchar* str) {
	gboolean result = FALSE;
	gboolean numeric_found = FALSE;
	gunichar ch = 0U;
	gint index = 0;
#line 84 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	g_return_val_if_fail (str != NULL, FALSE);
#line 85 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	numeric_found = FALSE;
#line 87 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	index = 0;
#line 88 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	while (TRUE) {
#line 668 "util-string.c"
		const gchar* _tmp0_ = NULL;
		gunichar _tmp1_ = 0U;
		gboolean _tmp2_ = FALSE;
		gunichar _tmp3_ = 0U;
		gboolean _tmp4_ = FALSE;
#line 88 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		_tmp0_ = str;
#line 88 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		_tmp2_ = string_get_next_char (_tmp0_, &index, &_tmp1_);
#line 88 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		ch = _tmp1_;
#line 88 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		if (!_tmp2_) {
#line 88 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
			break;
#line 684 "util-string.c"
		}
#line 89 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		_tmp3_ = ch;
#line 89 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		_tmp4_ = g_unichar_isdigit (_tmp3_);
#line 89 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		if (_tmp4_) {
#line 90 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
			numeric_found = TRUE;
#line 694 "util-string.c"
		} else {
			gunichar _tmp5_ = 0U;
			gboolean _tmp6_ = FALSE;
#line 91 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
			_tmp5_ = ch;
#line 91 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
			_tmp6_ = g_unichar_isspace (_tmp5_);
#line 91 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
			if (!_tmp6_) {
#line 92 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
				result = FALSE;
#line 92 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
				return result;
#line 708 "util-string.c"
			}
		}
	}
#line 95 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	result = numeric_found;
#line 95 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	return result;
#line 716 "util-string.c"
}


/**
 * Returns char from 0 to 9 converted to an int.  If a non-numeric value, -1 is returned.
 */
inline gint geary_string_digit_to_int (gchar ch) {
	gint result = 0;
	gchar _tmp0_ = '\0';
	gchar _tmp1_ = '\0';
	gboolean _tmp2_ = FALSE;
#line 102 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp1_ = ch;
#line 102 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp2_ = g_ascii_isdigit (_tmp1_);
#line 102 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	if (_tmp2_) {
#line 734 "util-string.c"
		gchar _tmp3_ = '\0';
#line 102 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		_tmp3_ = ch;
#line 102 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		_tmp0_ = _tmp3_ - '0';
#line 740 "util-string.c"
	} else {
#line 102 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		_tmp0_ = (gchar) (-1);
#line 744 "util-string.c"
	}
#line 102 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	result = (gint) _tmp0_;
#line 102 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	return result;
#line 750 "util-string.c"
}


gchar* geary_string_uint8_to_hex (guint8* buffer, int buffer_length1) {
	gchar* result = NULL;
	GString* builder = NULL;
	GString* _tmp0_ = NULL;
	gboolean first = FALSE;
	guint8* _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	GString* _tmp6_ = NULL;
	const gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
#line 106 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp0_ = g_string_new ("");
#line 106 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	builder = _tmp0_;
#line 108 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	first = TRUE;
#line 109 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp1_ = buffer;
#line 109 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp1__length1 = buffer_length1;
#line 774 "util-string.c"
	{
		guint8* byte_collection = NULL;
		gint byte_collection_length1 = 0;
		gint _byte_collection_size_ = 0;
		gint byte_it = 0;
#line 109 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		byte_collection = _tmp1_;
#line 109 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		byte_collection_length1 = _tmp1__length1;
#line 109 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		for (byte_it = 0; byte_it < _tmp1__length1; byte_it = byte_it + 1) {
#line 786 "util-string.c"
			guint8 byte = 0U;
#line 109 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
			byte = byte_collection[byte_it];
#line 790 "util-string.c"
			{
				gboolean _tmp2_ = FALSE;
				GString* _tmp4_ = NULL;
				guint8 _tmp5_ = 0U;
#line 110 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
				_tmp2_ = first;
#line 110 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
				if (!_tmp2_) {
#line 799 "util-string.c"
					GString* _tmp3_ = NULL;
#line 111 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
					_tmp3_ = builder;
#line 111 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
					g_string_append_c (_tmp3_, ' ');
#line 805 "util-string.c"
				}
#line 113 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
				_tmp4_ = builder;
#line 113 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
				_tmp5_ = byte;
#line 113 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
				g_string_append_printf (_tmp4_, "%X", (guint) _tmp5_);
#line 114 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
				first = FALSE;
#line 815 "util-string.c"
			}
		}
	}
#line 117 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp6_ = builder;
#line 117 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp7_ = _tmp6_->str;
#line 117 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 117 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	result = _tmp8_;
#line 117 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_g_string_free0 (builder);
#line 117 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	return result;
#line 831 "util-string.c"
}


gchar* geary_string_uint8_to_string (guint8* buffer, int buffer_length1) {
	gchar* result = NULL;
	GString* builder = NULL;
	GString* _tmp0_ = NULL;
	guint8* _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	GString* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
#line 121 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp0_ = g_string_new ("");
#line 121 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	builder = _tmp0_;
#line 122 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp1_ = buffer;
#line 122 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp1__length1 = buffer_length1;
#line 852 "util-string.c"
	{
		guint8* byte_collection = NULL;
		gint byte_collection_length1 = 0;
		gint _byte_collection_size_ = 0;
		gint byte_it = 0;
#line 122 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		byte_collection = _tmp1_;
#line 122 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		byte_collection_length1 = _tmp1__length1;
#line 122 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		for (byte_it = 0; byte_it < _tmp1__length1; byte_it = byte_it + 1) {
#line 864 "util-string.c"
			guint8 byte = 0U;
#line 122 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
			byte = byte_collection[byte_it];
#line 868 "util-string.c"
			{
				GString* _tmp2_ = NULL;
				guint8 _tmp3_ = 0U;
#line 123 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
				_tmp2_ = builder;
#line 123 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
				_tmp3_ = byte;
#line 123 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
				g_string_append_printf (_tmp2_, "%c", (gint) ((gchar) _tmp3_));
#line 878 "util-string.c"
			}
		}
	}
#line 125 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp4_ = builder;
#line 125 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp5_ = _tmp4_->str;
#line 125 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 125 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	result = _tmp6_;
#line 125 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_g_string_free0 (builder);
#line 125 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	return result;
#line 894 "util-string.c"
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 1282 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1282 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1282 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 907 "util-string.c"
	{
		GRegex* regex = NULL;
		const gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		GRegex* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
#line 1284 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp0_ = old;
#line 1284 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
#line 1284 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1284 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
#line 1284 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1284 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_g_free0 (_tmp2_);
#line 1284 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		regex = _tmp4_;
#line 1284 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1284 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 938 "util-string.c"
				goto __catch273_g_regex_error;
			}
#line 1284 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1284 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1284 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
			return NULL;
#line 947 "util-string.c"
		}
#line 1285 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp6_ = regex;
#line 1285 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp7_ = replacement;
#line 1285 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp8_ = g_regex_replace_literal (_tmp6_, self, (gssize) (-1), 0, _tmp7_, 0, &_inner_error_);
#line 1285 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp5_ = _tmp8_;
#line 1285 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1285 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1285 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 963 "util-string.c"
				goto __catch273_g_regex_error;
			}
#line 1285 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1285 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1285 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1285 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
			return NULL;
#line 974 "util-string.c"
		}
#line 1285 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp9_ = _tmp5_;
#line 1285 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp5_ = NULL;
#line 1285 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		result = _tmp9_;
#line 1285 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_g_free0 (_tmp5_);
#line 1285 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1285 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		return result;
#line 988 "util-string.c"
	}
	goto __finally273;
	__catch273_g_regex_error:
	{
		GError* e = NULL;
#line 1283 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		e = _inner_error_;
#line 1283 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_inner_error_ = NULL;
#line 1287 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		g_assert_not_reached ();
#line 1283 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_g_error_free0 (e);
#line 1002 "util-string.c"
	}
	__finally273:
#line 1283 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1283 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1283 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		g_clear_error (&_inner_error_);
#line 1283 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		return NULL;
#line 1013 "util-string.c"
	}
}


static gunichar string_get_char (const gchar* self, glong index) {
	gunichar result = 0U;
	glong _tmp0_ = 0L;
	gunichar _tmp1_ = 0U;
#line 1026 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1027 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp0_ = index;
#line 1027 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp1_ = g_utf8_get_char (((gchar*) self) + _tmp0_);
#line 1027 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	result = _tmp1_;
#line 1027 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	return result;
#line 1032 "util-string.c"
}


static gchar* string_slice (const gchar* self, glong start, glong end) {
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	glong _tmp2_ = 0L;
	glong _tmp5_ = 0L;
	gboolean _tmp8_ = FALSE;
	glong _tmp9_ = 0L;
	gboolean _tmp12_ = FALSE;
	glong _tmp13_ = 0L;
	glong _tmp16_ = 0L;
	glong _tmp17_ = 0L;
	glong _tmp18_ = 0L;
	glong _tmp19_ = 0L;
	glong _tmp20_ = 0L;
	gchar* _tmp21_ = NULL;
#line 1230 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1231 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1231 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1231 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1232 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp2_ = start;
#line 1232 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	if (_tmp2_ < ((glong) 0)) {
#line 1065 "util-string.c"
		glong _tmp3_ = 0L;
		glong _tmp4_ = 0L;
#line 1233 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp3_ = string_length;
#line 1233 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp4_ = start;
#line 1233 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		start = _tmp3_ + _tmp4_;
#line 1074 "util-string.c"
	}
#line 1235 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp5_ = end;
#line 1235 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	if (_tmp5_ < ((glong) 0)) {
#line 1080 "util-string.c"
		glong _tmp6_ = 0L;
		glong _tmp7_ = 0L;
#line 1236 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp6_ = string_length;
#line 1236 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp7_ = end;
#line 1236 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		end = _tmp6_ + _tmp7_;
#line 1089 "util-string.c"
	}
#line 1238 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp9_ = start;
#line 1238 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	if (_tmp9_ >= ((glong) 0)) {
#line 1095 "util-string.c"
		glong _tmp10_ = 0L;
		glong _tmp11_ = 0L;
#line 1238 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp10_ = start;
#line 1238 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp11_ = string_length;
#line 1238 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp8_ = _tmp10_ <= _tmp11_;
#line 1104 "util-string.c"
	} else {
#line 1238 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp8_ = FALSE;
#line 1108 "util-string.c"
	}
#line 1238 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	g_return_val_if_fail (_tmp8_, NULL);
#line 1239 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp13_ = end;
#line 1239 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	if (_tmp13_ >= ((glong) 0)) {
#line 1116 "util-string.c"
		glong _tmp14_ = 0L;
		glong _tmp15_ = 0L;
#line 1239 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp14_ = end;
#line 1239 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp15_ = string_length;
#line 1239 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp12_ = _tmp14_ <= _tmp15_;
#line 1125 "util-string.c"
	} else {
#line 1239 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp12_ = FALSE;
#line 1129 "util-string.c"
	}
#line 1239 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	g_return_val_if_fail (_tmp12_, NULL);
#line 1240 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp16_ = start;
#line 1240 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp17_ = end;
#line 1240 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	g_return_val_if_fail (_tmp16_ <= _tmp17_, NULL);
#line 1241 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp18_ = start;
#line 1241 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp19_ = end;
#line 1241 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp20_ = start;
#line 1241 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp21_ = g_strndup (((gchar*) self) + _tmp18_, (gsize) (_tmp19_ - _tmp20_));
#line 1241 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	result = _tmp21_;
#line 1241 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	return result;
#line 1151 "util-string.c"
}


gchar* geary_string_reduce_whitespace (const gchar* _s) {
	gchar* result = NULL;
	gchar* s = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
#line 129 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	g_return_val_if_fail (_s != NULL, NULL);
#line 130 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp0_ = _s;
#line 130 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 130 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	s = _tmp1_;
#line 131 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp2_ = s;
#line 131 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp3_ = string_replace (_tmp2_, "\n", " ");
#line 131 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_g_free0 (s);
#line 131 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	s = _tmp3_;
#line 132 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp4_ = s;
#line 132 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp5_ = string_replace (_tmp4_, "\r", " ");
#line 132 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_g_free0 (s);
#line 132 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	s = _tmp5_;
#line 133 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp6_ = s;
#line 133 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp7_ = string_replace (_tmp6_, "\t", " ");
#line 133 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_g_free0 (s);
#line 133 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	s = _tmp7_;
#line 134 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp8_ = s;
#line 134 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp9_ = string_strip (_tmp8_);
#line 134 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_g_free0 (s);
#line 134 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	s = _tmp9_;
#line 1208 "util-string.c"
	{
		gint i = 0;
#line 137 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		i = 1;
#line 1213 "util-string.c"
		{
			gboolean _tmp10_ = FALSE;
#line 137 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
			_tmp10_ = TRUE;
#line 137 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
			while (TRUE) {
#line 1220 "util-string.c"
				gint _tmp12_ = 0;
				const gchar* _tmp13_ = NULL;
				gint _tmp14_ = 0;
				gint _tmp15_ = 0;
				gboolean _tmp16_ = FALSE;
				const gchar* _tmp17_ = NULL;
				gint _tmp18_ = 0;
				gunichar _tmp19_ = 0U;
#line 137 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
				if (!_tmp10_) {
#line 1231 "util-string.c"
					gint _tmp11_ = 0;
#line 137 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
					_tmp11_ = i;
#line 137 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
					i = _tmp11_ + 1;
#line 1237 "util-string.c"
				}
#line 137 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
				_tmp10_ = FALSE;
#line 137 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
				_tmp12_ = i;
#line 137 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
				_tmp13_ = s;
#line 137 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
				_tmp14_ = strlen (_tmp13_);
#line 137 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
				_tmp15_ = _tmp14_;
#line 137 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
				if (!(_tmp12_ < _tmp15_)) {
#line 137 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
					break;
#line 1253 "util-string.c"
				}
#line 138 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
				_tmp17_ = s;
#line 138 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
				_tmp18_ = i;
#line 138 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
				_tmp19_ = string_get_char (_tmp17_, (glong) _tmp18_);
#line 138 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
				if (_tmp19_ == ((gunichar) ' ')) {
#line 1263 "util-string.c"
					const gchar* _tmp20_ = NULL;
					gint _tmp21_ = 0;
					gunichar _tmp22_ = 0U;
#line 138 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
					_tmp20_ = s;
#line 138 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
					_tmp21_ = i;
#line 138 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
					_tmp22_ = string_get_char (_tmp20_, (glong) (_tmp21_ - 1));
#line 138 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
					_tmp16_ = _tmp22_ == ((gunichar) ' ');
#line 1275 "util-string.c"
				} else {
#line 138 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
					_tmp16_ = FALSE;
#line 1279 "util-string.c"
				}
#line 138 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
				if (_tmp16_) {
#line 1283 "util-string.c"
					const gchar* _tmp23_ = NULL;
					gint _tmp24_ = 0;
					gchar* _tmp25_ = NULL;
					gchar* _tmp26_ = NULL;
					const gchar* _tmp27_ = NULL;
					gint _tmp28_ = 0;
					const gchar* _tmp29_ = NULL;
					gint _tmp30_ = 0;
					gint _tmp31_ = 0;
					gchar* _tmp32_ = NULL;
					gchar* _tmp33_ = NULL;
					gchar* _tmp34_ = NULL;
					gint _tmp35_ = 0;
#line 139 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
					_tmp23_ = s;
#line 139 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
					_tmp24_ = i;
#line 139 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
					_tmp25_ = string_slice (_tmp23_, (glong) 0, (glong) (_tmp24_ - 1));
#line 139 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
					_tmp26_ = _tmp25_;
#line 139 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
					_tmp27_ = s;
#line 139 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
					_tmp28_ = i;
#line 139 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
					_tmp29_ = s;
#line 139 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
					_tmp30_ = strlen (_tmp29_);
#line 139 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
					_tmp31_ = _tmp30_;
#line 139 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
					_tmp32_ = string_slice (_tmp27_, (glong) _tmp28_, (glong) _tmp31_);
#line 139 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
					_tmp33_ = _tmp32_;
#line 139 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
					_tmp34_ = g_strconcat (_tmp26_, _tmp33_, NULL);
#line 139 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
					_g_free0 (s);
#line 139 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
					s = _tmp34_;
#line 139 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
					_g_free0 (_tmp33_);
#line 139 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
					_g_free0 (_tmp26_);
#line 140 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
					_tmp35_ = i;
#line 140 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
					i = _tmp35_ - 1;
#line 1333 "util-string.c"
				}
			}
		}
	}
#line 144 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	result = s;
#line 144 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	return result;
#line 1342 "util-string.c"
}


gchar* geary_string_safe_byte_substring (const gchar* s, gssize max_length) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gssize _tmp3_ = 0L;
	const gchar* _tmp6_ = NULL;
	const gchar* _tmp7_ = NULL;
	gssize _tmp8_ = 0L;
	gint _tmp9_ = 0;
	gchar* _tmp10_ = NULL;
#line 151 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	g_return_val_if_fail (s != NULL, NULL);
#line 152 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp0_ = s;
#line 152 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp1_ = strlen (_tmp0_);
#line 152 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp2_ = _tmp1_;
#line 152 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp3_ = max_length;
#line 152 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	if (((gssize) _tmp2_) < _tmp3_) {
#line 1369 "util-string.c"
		const gchar* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
#line 153 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		_tmp4_ = s;
#line 153 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 153 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		result = _tmp5_;
#line 153 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
		return result;
#line 1380 "util-string.c"
	}
#line 155 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp6_ = s;
#line 155 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp7_ = s;
#line 155 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp8_ = max_length;
#line 155 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp9_ = g_utf8_strlen (_tmp7_, _tmp8_);
#line 155 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	_tmp10_ = g_utf8_substring (_tmp6_, (glong) 0, (glong) _tmp9_);
#line 155 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	result = _tmp10_;
#line 155 "/builddir/build/BUILD/geary-0.8.1/src/engine/util/util-string.vala"
	return result;
#line 1396 "util-string.c"
}



